Attribute VB_Name = "basCommand"
Option Explicit

Sub ExecuteCommandwithParms()
'Execute a Stored Procedure
'With Parameters and creating an
'individual parameter object for
'each parameter in the procedure

Dim conn As ADODB.Connection
Dim cmd As ADODB.Command
Dim prm As ADODB.Parameter

Set conn = New ADODB.Connection

'Establish a connection to the database
With conn
    .Provider = "SQLOLEDB"
    .ConnectionString = "data source=batgirl;user id=sa;initial catalog=pubs"
    .Open
End With

'Set up a command object
Set cmd = New ADODB.Command
With cmd
    .ActiveConnection = conn
    .CommandText = "byroyalty"
    .CommandType = adCmdStoredProc
End With

'Set up the parameter object
Set prm = New ADODB.Parameter
With prm
    .Name = "@percentage"
    .Direction = adParamInput
    .Type = adInteger
    .Value = 50
End With
cmd.Parameters.Append prm

'Open a recordset based on the executed command
Dim rst As ADODB.Recordset
Set rst = cmd.Execute

'Loop through the results
Do Until rst.EOF
    Debug.Print rst!au_id
    rst.MoveNext
Loop

'Clean up
rst.Close
conn.Close
Set rst = Nothing
Set conn = Nothing
Set cmd = Nothing
Set prm = Nothing

End Sub

Sub CommandReturnValues()

'A copy of the Stored Procedure:
'CREATE  PROCEDURE sp_CmdWithPram  AS
'
'/*Return Value*/
'Return 55

Dim conn As ADODB.Connection
Dim cmd As ADODB.Command

Set conn = New ADODB.Connection
Set cmd = New ADODB.Command

'Establish a connection to the database
With conn
    .Provider = "SQLOLEDB"
    .ConnectionString = "data source=batgirl;user id=sa;initial catalog=northwind"
    .Open
End With

'Set up the command object to
'point to the Stored Procedure
With cmd
    .CommandText = "sp_CmdWithPram"
    .CommandType = adCmdStoredProc
    .ActiveConnection = conn
    .Parameters.Refresh
End With

cmd.Execute
MsgBox "return value: " & cmd.Parameters(0).Value

conn.Close
Set conn = Nothing
   
End Sub

Sub ExecuteCommandwithCreateParms()
'Execute a Parameter Query w/o
'Having to create Parameter Objects
'Here we use the CreateParameter method

Dim conn As ADODB.Connection
Dim cmd As ADODB.Command

Set conn = New ADODB.Connection

'Establish a connection to the database
With conn
    .Provider = "SQLOLEDB"
    .ConnectionString = "data source=batgirl;user id=sa;initial catalog=pubs"
    .Open
End With

'Set up a command object
Set cmd = New ADODB.Command
With cmd
    .ActiveConnection = conn
    .CommandText = "byroyalty"
    .CommandType = adCmdStoredProc
    
    'Set up the parameter info
    'Here we use the Create Parameter Method
    'Of the Command Object to simplify your code
    .Parameters.Append .CreateParameter("@Percentage", _
            adInteger, adParamInput, , 50)
    
End With

'Open a recordset based on the executed command
Dim rst As ADODB.Recordset
Set rst = cmd.Execute

'Loop through the results
Do Until rst.EOF
    Debug.Print rst!au_id
    rst.MoveNext
Loop

'Clean up
rst.Close
conn.Close

Set rst = Nothing
Set conn = Nothing
Set cmd = Nothing

End Sub

Sub ExecuteCommandwithParmRefresh()
'Execute a Parameter Query w/o
'Having to use Parameter Objects
'Helpful with Stored Procedures that have
'A whole lot of Parameters

Dim conn As ADODB.Connection
Dim cmd As ADODB.Command

Set conn = New ADODB.Connection

'Establish a connection to the database
With conn
    .Provider = "SQLOLEDB"
    .ConnectionString = "data source=batgirl;user id=sa;initial catalog=pubs"
    .Mode = adModeRead
    .Open
End With

'Set up a command object
Set cmd = New ADODB.Command
With cmd
    .ActiveConnection = conn
    .CommandText = "byroyalty"
    .CommandType = adCmdStoredProc
    
    'This example uses the Parameter's Refresh
    'Method to get the parameters from the server
    'And then fill their values before execute
    'Avoids needing to have to Create/Append Parameters
    .Parameters.Refresh
    .Parameters("@Percentage").Value = 50
End With

'Open a recordset based on the executed command
Dim rst As ADODB.Recordset
Set rst = cmd.Execute

'Loop through the results
Do Until rst.EOF
    Debug.Print rst!au_id
    rst.MoveNext
Loop

'Clean up
rst.Close
conn.Close
Set rst = Nothing
Set conn = Nothing
Set cmd = Nothing

End Sub
