Attribute VB_Name = "basCreatableRst"
Option Explicit


Sub SimpleCreatableRst()
'This is an example of creating a recordset
'Without connecting to a database
'Great for Non-relational data
'Also great for text files, etc

Dim rst As ADODB.Recordset
Set rst = New ADODB.Recordset

With rst
    'Do local work when creating a rst
    .CursorLocation = adUseClient
    
    'Add some fields here
    With .Fields
        .Append "CustomerID", adInteger, , adFldRowID
        .Append "Name_First", adVarChar, 20, adFldIsNullable
        .Append "Name_Last", adWChar, 50, adFldIsNullable
    End With
    
    'Open the rst
    .Open , , adOpenStatic, adLockBatchOptimistic
    
    'Add some records
    'using the array function to save space
    'can you the normal ADDNEW method if you like
    .AddNew Array("CustomerID", "Name_First", "Name_Last"), _
        Array(1, "Steve", "Forte")
    .AddNew Array("CustomerID", "Name_First", "Name_Last"), _
        Array(2, "Tom", "Howe")
    .AddNew Array("CustomerID", "Name_First", "Name_Last"), _
        Array(3, "Ken", "Getz")
    .AddNew Array("CustomerID", "Name_First", "Name_Last"), _
        Array(4, "Richard", "Campbell")
        
    'Move to the First Record since
    'We are at the last record now
    .MoveFirst
    
    'Loop through the contents of the recordset
    'And write the contents to the debug window
    Do Until .EOF
        Debug.Print !Name_First & " " & !Name_Last
        rst.MoveNext
    Loop
    
    'Remember that we can also pass this recordset to
    'antoher calling function if you like
    'the calling function does not care where your
    'recordset came from, all it cares about is that
    'your recordset is an ADO recordset
    
    'close the recordset and clean up
    rst.Close
    Set rst = Nothing
    
    
End With


End Sub


Sub CreatableRst_Files(strPath As String)
'This is an example of creating a recordset
'from Non-relational data
'Creates a recordset of file names And Extensions

'Show a recordset created from a list of Files in a directory
'Will be an alternative  to the NT Dir Serverices OLE DB Provider
'Can also call from an ASP for a download listing, etc

Dim rst As ADODB.Recordset
Set rst = New ADODB.Recordset

With rst
    'Do local work
    .CursorLocation = adUseClient
    
    'Add a field here
     .Fields.Append "FileName", adVarChar, 255, adFldRowID
     .Fields.Append "Extention", adChar, 3, adFldFixed
      
    'Open the rst
    .Open , , adOpenStatic, adLockBatchOptimistic
    
     'The following code gets the
     'File information from the directory
     'that the user specified
     
     'Make sure there is an \ in the path
     If Right(strPath, 1) <> "\" Then strPath = strPath & "\"
     
     'Get a list of all files in the DIR and then add then to
     'the recordset
      strPath = Dir(strPath & "*.*", vbNormal)
      
      ' Don't include the . and .. entries
      Do While strPath > ""
                
        'Add the record to the rst here
         .AddNew Array("FileName", "Extention"), _
        Array(strPath, Right(strPath, 3))
        
        strPath = Dir
      Loop
        
    .MoveFirst
    
    'Print out the files
    Do Until .EOF
        Debug.Print !FileName
        rst.MoveNext
    Loop
    
    
End With

End Sub
