Attribute VB_Name = "basNativeProviders"
Option Explicit

Sub ConnectViaDataLink()
'This example uses a datalink (UDL) file
'To store the connection information
'Then we will read the connection info
'Into the conn.open method

Dim conn As ADODB.Connection
Dim rst As ADODB.Recordset

Set conn = New ADODB.Connection

'Open a connection based on the UDL file
conn.Open "File Name=" & App.Path & "\hcado.UDL;"

'Display the Provider info to the user
MsgBox "Connected to " & conn.Provider, vbInformation
'Create and open a recordset based
'on the Customer's Table
Set rst = New ADODB.Recordset
rst.Open "Customers", conn

MsgBox rst!CompanyName, vbInformation

'Clean Up
rst.Close
Set rst = Nothing

End Sub

Sub ConnectViaCreatableUDL()
'This example uses a the datalink (UDL)
'dialog box to get the connection
'information from the user at run-time
'Then we will read the connection info
'Into the rst.open method

'Must set a reference to
'"Microsoft OLE DB Service Component 1.0"
'Type Library to use MSDASC.DataLinks
Dim udl As MSDASC.DataLinks
Dim rst As ADODB.Recordset
Dim strConnect As String

Set udl = New MSDASC.DataLinks

'Bring up the UDL Dialog Box
'And store the connection information
'inside the strConnect variable
strConnect = udl.PromptNew

'Create and open a recordset based
'on the Customer's Table
Set rst = New ADODB.Recordset
rst.Open "Customers", strConnect

MsgBox rst!CompanyName, vbInformation

'Clean Up
rst.Close
Set rst = Nothing

End Sub

Sub Jet()
'This procedure will connect to JET

Dim conn As ADODB.Connection
Dim rst As ADODB.Recordset

Set conn = New ADODB.Connection

With conn
    .Provider = "Microsoft.Jet.OLEDB.3.51"
    .ConnectionString = "data source=" & _
        App.Path & "\sample.mdb"
    .Mode = adModeRead
    .Open
End With

MsgBox "Connected to " & conn.Provider, vbInformation
'Create and open a recordset based
'on the Customer's Table
Set rst = New ADODB.Recordset
rst.Open "Customers", conn

MsgBox rst!CompanyName, vbInformation

'Clean Up
rst.Close
Set rst = Nothing

End Sub


Sub SQLServer()
'This procedure will connect to SQL Server
Dim conn As ADODB.Connection
Dim rst As ADODB.Recordset

Set conn = New ADODB.Connection

With conn
    .Provider = "SQLOLEDB"
    .ConnectionString = "data source=Robin; " & _
        "user id=sa;initial catalog=Northwind"
    .Mode = adModeRead
    .Open
End With

MsgBox "Connected to " & conn.Provider, vbInformation
'Create and open a recordset based
'on the Customer's Table
Set rst = New ADODB.Recordset
rst.Open "Customers", conn

MsgBox rst!CompanyName, vbInformation

'Clean Up
rst.Close
Set rst = Nothing

'We can also use this as a connection string:
'.ConnectionString = "server=BATGIRL;user id=sa;database=Northwind"

End Sub


Sub Oracle()
'This procedure will connect to Oracle

Dim conn As ADODB.Connection
Set conn = New ADODB.Connection


With conn
    .Provider = "MSDAORA"
    .ConnectionString = "Data Source=Catwoman;User ID=steve;Password=steve"
    .Mode = adModeRead
    .Open
End With

MsgBox "Connected to " & conn.Provider, vbInformation

End Sub

