VERSION 5.00
Object = "{0ECD9B60-23AA-11D0-B351-00A0C9055D8E}#6.0#0"; "mshflxgd.ocx"
Begin VB.Form frmPersistent 
   Caption         =   "Persistent Recordsets"
   ClientHeight    =   4188
   ClientLeft      =   60
   ClientTop       =   348
   ClientWidth     =   6756
   Icon            =   "frmPersistent.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   4188
   ScaleWidth      =   6756
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdIE 
      Caption         =   "View in I.E. 5"
      Height          =   375
      Left            =   5280
      TabIndex        =   7
      Top             =   120
      Width           =   1095
   End
   Begin VB.CommandButton cmdResync 
      Caption         =   "Re-Sync"
      Height          =   375
      Left            =   2160
      TabIndex        =   6
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "Save"
      Height          =   375
      Left            =   720
      TabIndex        =   5
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton cmdShowBoth 
      Caption         =   "Show Both"
      Height          =   375
      Left            =   3720
      TabIndex        =   2
      Top             =   120
      Width           =   1335
   End
   Begin MSHierarchicalFlexGridLib.MSHFlexGrid MSHFlexGrid2 
      Height          =   1215
      Left            =   240
      TabIndex        =   1
      Top             =   2880
      Width           =   5655
      _ExtentX        =   9970
      _ExtentY        =   2138
      _Version        =   393216
      FixedCols       =   0
      _NumberOfBands  =   1
      _Band(0).Cols   =   2
   End
   Begin MSHierarchicalFlexGridLib.MSHFlexGrid MSHFlexGrid1 
      Height          =   1095
      Left            =   240
      TabIndex        =   0
      Top             =   1200
      Width           =   5535
      _ExtentX        =   9758
      _ExtentY        =   1926
      _Version        =   393216
      FixedCols       =   0
      _NumberOfBands  =   1
      _Band(0).Cols   =   2
   End
   Begin VB.Label Label2 
      Caption         =   "On Disk"
      Height          =   375
      Left            =   240
      TabIndex        =   4
      Top             =   2400
      Width           =   1575
   End
   Begin VB.Label Label1 
      Caption         =   "In Database"
      Height          =   375
      Left            =   240
      TabIndex        =   3
      Top             =   720
      Width           =   1575
   End
End
Attribute VB_Name = "frmPersistent"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Sub RstPersistence_Save()

'This example will show you how to
'take a recordset, disconnect it from the database,
'store it on disk and then sync it to the db
'The resync happens in RstPersistence_Open

Dim strSQL As String
Dim strMsg As String
Dim strNewValue As String
Dim conn As ADODB.Connection
Dim rst As ADODB.Recordset

On Error GoTo Proc_Err

'Grab one record for our example
strSQL = "Select * From Customers Where CustomerID='ALFKI'"

'Create a connection to the database
Set conn = New ADODB.Connection
With conn
    .Provider = "Microsoft.Jet.OLEDB.4.0"
    .ConnectionString = "data source=" & _
            App.Path & "\sample.mdb"
    .Open
End With

Set rst = New ADODB.Recordset

'Must use a client cursor with the operation
rst.CursorLocation = adUseClient
rst.Open strSQL, _
    conn, adOpenStatic, adLockBatchOptimistic

'Ask the user to change the record, but
'show the user the current data
strMsg = "Please Enter in a new CompanyName for: " & _
    rst!CompanyName & vbNewLine & _
    "This CustomerID=" & rst!CustomerID
    
'Get the New Name
strNewValue = InputBox(strMsg)

'Change a record only on client and save to disk
'This does NOT make the change to the database
rst.Update "CompanyName", strNewValue
'The change was only committed to the client recordset

On Error Resume Next
'Get rid of the current file to make room for the new one
Kill App.Path & "\hcado.xml"

On Error GoTo Proc_Err
'Save the recordset to disk
rst.Save App.Path & "\hcado.xml", adPersistXML

rst.Close
Set rst = Nothing

MsgBox "Saved to: " & App.Path & "\hcado.xml", vbInformation

Proc_Exit:
    Exit Sub

Proc_Err:
    MsgBox Err.Description
    Resume Proc_Exit
    
End Sub
Sub RstPersistence_Open()

'This example will show you how to
'take a recordset, disconnect it from the database,
'store it on disk and then sync it to the db
'The data dump happened in RstPersistence_Save
'The resync happens here

Dim conn As ADODB.Connection
Dim rst As ADODB.Recordset
Dim strSQL As String
Dim strMsg As String

On Error GoTo Proc_Err


'Open a NEW recordset from Disk
'not from a database
'We do this by not supplying a connection object/string
Set rst = New ADODB.Recordset
rst.Open App.Path & "\hcado.xml", , adOpenStatic, adLockBatchOptimistic, adCmdFile

'Shows the Original Value vs Saved on Disk
'using the OriginalValue property
strMsg = "Value in DataSource: " & _
                rst!CompanyName.OriginalValue
strMsg = strMsg & vbNewLine & _
    "Value on Disk           : " & rst!CompanyName

'Display the values
MsgBox strMsg, vbInformation, "Original Value vs Saved on Disk"

'Ok, now update the database with the disk's version
'must reconnect to the database now
'Set a connection back to the origional
'database connection
Set conn = New ADODB.Connection
With conn
    .Provider = "Microsoft.Jet.OLEDB.4.0"
    .ConnectionString = "data source=" & _
            App.Path & "\sample.mdb"
    .Open
End With

'reconnect the recordset to the
'the database and resync
'You can reconnect by setting the
'ActiveConnection property
rst.ActiveConnection = conn
rst.UpdateBatch

MsgBox "Database Re-Synced!", vbInformation

Proc_Exit:
    Exit Sub

Proc_Err:
    MsgBox Err.Description
    Resume Proc_Exit
    
End Sub

Private Sub cmdIE_Click()
  frmBrowser.Show
End Sub

Private Sub cmdResync_Click()
  Resynch
End Sub

Private Sub cmdSave_Click()
  Persist
End Sub

Private Sub cmdShowBoth_Click()

'Open up two recordsets:
'one of the recordsets exists
'on disk as XML and the other is
'in our database

Dim strSQL As String
Dim rst As ADODB.Recordset
Dim conn As ADODB.Connection
Dim rst2 As ADODB.Recordset

Set rst = New ADODB.Recordset
Set rst2 = New ADODB.Recordset

'Need to grab one record
strSQL = "Select * From Customers Where CustomerID='ALFKI'"

'Set up a connection to the database
Set conn = New ADODB.Connection
With conn
    .Provider = "Microsoft.Jet.OLEDB.4.0"
    .ConnectionString = "data source=" & _
            App.Path & "\sample.mdb"
    .Open
End With


rst.CursorLocation = adUseClient
rst.Open strSQL, conn

'Open the recordset off disk
rst2.Open App.Path & "\hcado.xml", , adOpenStatic, adLockBatchOptimistic, adCmdFile

'Fill the grids with the data
Set Me.MSHFlexGrid1.Recordset = rst
Set Me.MSHFlexGrid2.Recordset = rst2

End Sub
